Public Class Form2

    Dim file As String
    Dim ReEdit As Boolean
    Dim BusyNow As Boolean
    Dim Modified As Boolean

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        WebBrowser1.Navigate(amlDir)
    End Sub

    ''' <summary>
    ''' ToolStrip#################################################################################################
    ''' </summary>

    Private Sub NewButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewButton.Click
        If Modified_Check() = False Then Exit Sub
        ListView1.Items.Clear()
    End Sub

    Private Sub OpenButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenButton.Click

        Dim temp(1) As String
        If Modified_Check() = False Then Exit Sub

        rlt = OpenFileDialog1.ShowDialog
        If rlt = Windows.Forms.DialogResult.Cancel Then Exit Sub

        ListView1.Items.Clear()
        file = OpenFileDialog1.FileName
        If My.Computer.FileSystem.FileExists(file) = False Then Exit Sub

        LoadFile(file)
    End Sub

    Private Sub SaveMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveMenu.Click

        If My.Computer.FileSystem.FileExists(file) = False Then
            SaveAsMenu_Click(Nothing, Nothing)
            Exit Sub
        End If

        Call Save_Core()
    End Sub

    Private Sub SaveAsMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsMenu.Click

        file = InputBox("ۑt@C͂ĂB", soft)

        file = amlDir & file & ".aml"
        'rlt = SaveFileDialog1.ShowDialog
        'If rlt = Windows.Forms.DialogResult.Cancel Then Exit Sub

        'file = SaveFileDialog1.FileName
        Call Save_Core()
    End Sub

    Private Sub ReEditButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReEditButton.Click

        If ListView1.Items.Count = 0 Then Exit Sub
        If ListView1.SelectedItems.Count = 0 Then Exit Sub

        Dim Value As String = InputBox("JԂ(-1ɂƖɂȂ܂)A " & vbCrLf & "܂͑ҋ@b͂Ă", "C")

        If IsNumeric(Value) = False Then Exit Sub
        ListView1.SelectedItems(0).SubItems(1).Text = Value
    End Sub

    Private Sub DeleteButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteButton.Click

        If ListView1.Items.Count = 0 Then Exit Sub
        If ListView1.SelectedItems.Count = 0 Then Exit Sub

        ListView1.Items.Remove(ListView1.SelectedItems(0))
        Modified = True
    End Sub

    Private Sub AddWaitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddWaitButton.Click

        Dim Value As String = InputBox("ҋ@bw肵Ă", "ҋ@Ԃ̎w")
        If IsNumeric(Value) = False Then Exit Sub
        AddListViewItem("ҋ@܂", Value)

    End Sub

    Private Sub ItemDownButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemDownButton.Click

        With ListView1
            If .Items.Count = 0 Then Exit Sub
            If .SelectedItems.Count = 0 Then Exit Sub
            If .SelectedItems(0).Index >= .Items.Count - 1 Then Exit Sub

            Dim index As Integer = .SelectedItems(0).Index
            Dim listrow As ListViewItem = .SelectedItems(0)
            .SelectedItems(0).Remove()
            .Items.Insert(index + 1, listrow)
            .Items(index + 1).Focused = True
        End With

    End Sub

    Private Sub ItemUpButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemUpButton.Click

        With ListView1
            If .Items.Count = 0 Then Exit Sub
            If .SelectedItems.Count = 0 Then Exit Sub
            If .SelectedItems(0).Index <= 0 Then Exit Sub
            Dim index As Integer = .SelectedItems(0).Index
            Dim listrow As ListViewItem = .SelectedItems(0)
            .SelectedItems(0).Remove()
            .Items.Insert(index - 1, listrow)
            .Items(index - 1).Focused = True
        End With

    End Sub

    ''' <summary>
    ''' Other Objects#############################################################################
    ''' </summary>
    '''  
    Private Sub Form1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ListView1.DragDrop

        Dim path As String = e.Data.GetData(DataFormats.FileDrop)(0)

        If System.IO.Directory.Exists(path) = True Then AddListViewItem(path, True)

        If System.IO.File.Exists(path) = False Then Exit Sub
        If path.EndsWith(".amf") = False Then
            MsgBox("hbvł̂͂}EXt@C(.amf)łB", _
                                    MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation Or MsgBoxStyle.MsgBoxSetForeground, soft)
            Exit Sub
        End If

        Dim Value As String = InputBox("JԂ(-1ɂƖɂȂ܂)", soft)
        If IsNumeric(Value) = False Then
            MsgBox("l͂ĂB", _
                                              MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation Or MsgBoxStyle.MsgBoxSetForeground, soft)
            Exit Sub
        End If

        AddListViewItem(path, Value)

    End Sub

    Private Sub Form1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ListView1.DragEnter

        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub ListView1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ListView1.KeyUp
        If ListView1.SelectedItems.Count = 0 Then Exit Sub
        If e.KeyCode = Keys.Delete Then DeleteButton.PerformClick()
    End Sub

    Private Sub WebBrowser1_DocumentTitleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles WebBrowser1.DocumentTitleChanged

        If BusyNow = True Then Exit Sub
        BusyNow = True

        If WebBrowser1.Url.LocalPath & "\" <> amlDir Then
            WebBrowser1.Navigate(amlDir)
        End If

    End Sub

    Private Sub WebBrowser1_Navigated(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserNavigatedEventArgs) Handles WebBrowser1.Navigated
        BusyNow = False
    End Sub

    ''' <summary>
    ''' CoreSystem#################################################
    ''' </summary>

    Public Sub AddListViewItem(ByVal FileName As String, ByVal value As String)

        Dim Listrow As ListViewItem

        If FileName <> "ҋ@܂" Then FileName = System.IO.Path.GetFileName(FileName)

        Listrow = New ListViewItem(FileName, 0)
        Listrow.SubItems.Add(value)

        If ListView1.Items.Count = 0 Then ListView1.Items.Add(Listrow) : Exit Sub
        If ListView1.SelectedItems.Count = 0 Then ListView1.Items.Add(Listrow) : Exit Sub
        If ListView1.SelectedItems.Count > 0 Then

            If ReEdit = True Then
                Dim idx As Integer = ListView1.FocusedItem.Index
                ListView1.FocusedItem.Remove()
                ListView1.Items.Insert(idx, Listrow)
            Else
                ListView1.Items.Add(Listrow)
                ListView1.Items(ListView1.Items.Count - 1).Selected = True
            End If

        End If

        ReEdit = False

    End Sub

    Private Sub LoadFile(ByVal tfile As String)

        Dim temp(1) As String
        Dim tempbool(1) As Boolean

        Try
            FileOpen(1, tfile, OpenMode.Input)

            Input(1, tempbool(0))
            Input(1, tempbool(1))

            ConfigMsgMenu.Checked = tempbool(0)
            ConfigLoopMenu.Checked = tempbool(1)

            Do Until EOF(1)

                Input(1, temp(0))
                Input(1, temp(1))
                AddListViewItem(temp(0), temp(1))

            Loop

        Catch ex As Exception
            MsgBox("G[Ft@C̓ǂݍ" & vbCrLf & Err.Description, _
             MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation Or MsgBoxStyle.MsgBoxSetForeground, soft)
        End Try

        FileClose()
    End Sub

    Private Sub Save_Core()

        Try
            FileOpen(1, file, OpenMode.Output)
            WriteLine(1, ConfigMsgMenu.Checked, ConfigLoopMenu.Checked)

            For i As Integer = 0 To ListView1.Items.Count - 1
                WriteLine(1, ListView1.Items(i).Text, ListView1.Items(i).SubItems(1).Text)
            Next

        Catch ex As Exception
            MsgBox("G[Ft@C̕ۑ" & vbCrLf & Err.Description, _
             MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation Or MsgBoxStyle.MsgBoxSetForeground, soft)
        Finally
            FileClose()
            Modified = False
        End Try

    End Sub

    Private Function Modified_Check() As Boolean

        If Modified = False Then Return (True)

        msgrlt = MsgBox("t@CύXĂ܂Bۑ܂H", _
         MsgBoxStyle.YesNoCancel Or MsgBoxStyle.Question Or MsgBoxStyle.MsgBoxSetForeground, soft)

        If msgrlt = MsgBoxResult.Cancel Then Return (False)

        If msgrlt = MsgBoxResult.Yes Then

            If My.Computer.FileSystem.FileExists(file) = True Then
                SaveMenu.PerformClick()
            Else
                SaveAsMenu.PerformClick()
            End If

        End If
        Modified = False

        Return (True)
    End Function

    Private Sub Form2_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Modified_Check() = False Then e.Cancel = True
    End Sub

    Private Sub SaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveButton.Click

    End Sub
End Class